#include "sorting.h"

int IncreaseSort( const void *elm1, const void *elm2)
{
	double value1 = ((SortStruct *)elm1)->value;
	double value2 = ((SortStruct *)elm2)->value;

	if ( value1 < value2 )
		return -1;
	else if ( value1 == value2 )
		return 0;
	else
		return 1;
}


int DecreaseSort( const void *elm1, const void *elm2)
{
	double value1 = ((SortStruct *)elm1)->value;
	double value2 = ((SortStruct *)elm2)->value;

	if ( value1 < value2 )
		return 1;
	else if ( value1 == value2 )
		return 0;
	else
		return -1;
}

void GetHorizontalPositions(int size, double* xPos, double *yPos, double &x, double &y)
{
    int w, h;
	w = sqrt((float)size);
    h = size / w;

    if (size != w*h)
		h += 1;

    x = 1.0/w;
    y = 1.0/h;
    double halfx = x / 2.;
    double halfy = y / 2.;

    int xc, yc;
    for (int j = 0; j < size; j++)
	{
        yc = j / w;
        xc = j % w;

        xPos[j] = xc * x + halfx;
        yPos[j] = yc * y + halfy;
    }
}

void GetSpiralPositions(int size, double* xPos, double *yPos, double &x, double &y)
{
    int w, h;
	w = sqrt((float)size);
    h = w;
	if (size > w*w)
		w += 1;

    x = 1.0 / w;
    y = 1.0 / h;

	int centerx, centery;
	centerx = w/2;
	centery = w/2;
	int add_case = 0;
	int enum_num = 2;
	int count = 0;

	int position;
    double halfx = x / 2;
    double halfy = y / 2;
    for (int j = 0; j < size; j++)
	{
        xPos[j] = centerx * x + halfx;
        yPos[j] = centery * y + halfy;
        switch (add_case) 
		{
		case 0: 
			centery -= 1;
			break;
		case 1: 
			centerx -= 1;
			break;
		case 2: 
			centery += 1;
			break;
		case 3: 
			centerx += 1;
			break;
		}

		count++;
		if (count == enum_num/2)
		{
			count = 0;
			enum_num ++;
			switch (add_case) 
			{
			case 0: 
				add_case = 1;
				break;
			case 1: 
				add_case = 2;
				break;
			case 2: 
				add_case = 3;
				break;
			case 3: 
				add_case = 0;
				break;
			}
		}
	}

}
