#pragma once

#include <Math.h>
#include <iostream>

using namespace std ;

// Adapted from http://www-fs.informatik.uni-tuebingen.de/~reinhard/hcurve.html

class HCurve
{

public:
	HCurve(int n,int m);	// n-by-m grid
	int xco(int i);				// x-coordinate
	int yco(int i);				// y-coordinate

private:
	class Rect							// for rectangular grids
	{
		public:
			Rect();
			int x,y,g,h;
			Rect *lo, *ro, *lu, *ru, *sp;
			int xcor(int i); 
			int ycor(int i);
	};
	int width;	//grid width
	int height;	//grid height
	bool squaregrid;
	int xco_sqr(int i,int n);			//square grid (n-by-n)
	int yco_sqr(int i,int n);			//square grid (n-by-n)
	int xco_rect(int i);				//rectangular grid (n-by-m)
	int yco_rect(int i);				//rectangular grid (n-by-m)
	int xcod(int i,int n);				// used by xco (square grid)
	int ycod(int i,int n);				// used by yco (square grid)
	bool bfel[257];						// used by rectangle grid
	bool bfeld[257][257];				// used by rectangle grid
	Rect* fel[257];						// used by rectangle grid
	Rect* feld[257][257];				// used by rectangle grid
	Rect* felds(int xm, int ym);		// used by rectangle grid
	Rect* fels(int xm);					// used by rectangle grid
	bool iseven(int i);


};
