#pragma once

#include <stdio.h>
#include <iostream>
#include "HCurve.h"

class TreeMap
{
	public:
		TreeMap(const char* inputfile, const char* outputfile,double diff);
	private:
		// Variables
		const char* infile; //input file name (.cg)
		const char* outfile; //output file name (.tm)
		int gsizex; // grid size 
		int gsizey; // grid size 
		int nnodes; // number of nodes;
		int ndata; // number of dataitems
		int** dataset; // read from input file
		int* leafnodes; // stores references to the leafnodes of the cluster tree
		int leafcount; // number of leaf-nodes counter (as they are found - depth first)
		// Methods
		void Create(double diff);
		void ReadFile(); 
		bool IsOdd(int i); 
		void CalcGridSize(double diff);
		void GetLeafNodes(int i);	
};
