#ifndef _COLOR_MANAGER_H
#define _COLOR_MANAGER_H

#include <string>
#include <fstream>
#include <stdio.h>
#include "../Basic/CLinkList.h"

#include "ColorSetting.h"


class ColorManager
{
public:
    enum Theme
    {
        ORIGINAL,
        NOCTURNAl,
        GRAYS,
        MIDNIGHT_BLUE,
        SEA_GREEN
    };

protected:
    Theme theme;
    ColorSetting** colorSettings;
    int settingNum;

public:
	ColorManager();
	~ColorManager();

    void SetTheme(Theme theme);
    ColorSetting* GetColorSetting(int type, int id = 0);
    void InvertColors();
    bool IsSingleColor(int type, int id = 0);
//    RGBt GetColor(int type, int id = 0, ARR<double> values = NULL);
    RGBt GetColor(int type, int id = 0);
    RGBt GetColor(int type, int id, float value);
    void SetColor(int type, int id = 0, RGBt color = RGBt(0x009900));
    void SetColorScale(int type, int id = 0, ColorSetting::ColorScale scale = ColorSetting::LIGHTNESS);
    void SetSingleColor(int type, int id = 0);

};

#endif

