#ifndef _COLOR_SETTING_H
#define _COLOR_SETTING_H

#include "../Basic/RGB.h"
#include "../Basic/ARR.h"
#include "colorramp.h"

class ColorSetting
{
public:
    enum ColorScale 
    {
        UNION,
        LIGHTNESS,
        SATURATION,
        SATURATION_LIGHTNESS,
        GREYS_CALE,
        MAGENTA,
        HEATED_OBJECT,
        SBB_COLOR
    };

protected:
    ColorScale colorScale;
    RGBt baseColor;
    RGBt ** colors; // store pre-defined colors

    ColorRamp* ramp;

public:
	ColorSetting();
    ColorSetting(RGBt baseColor);
	~ColorSetting();

    bool IsSingleColor();
 //   RGBt GetColor(ARR<double> values = NULL);
    RGBt GetColor(float value);
    RGBt GetColor();
    void SetColor(RGBt color);
    bool SetColorScale(ColorScale scale);
    void InvertColor();

protected:
	bool LoadMagentaColorData();
    bool LoadHeatedObjectColorData();

};

#endif

