#include <FLOAT.h>
#include <string>
#include <stdio.h>

#include "AggregatedDimension.h"


//constructor
AggregatedDimension::AggregatedDimension() 
{
    type = AGGREGATEDDIMENSION;
    max = -1;
    min = 0;

    interval = 1.0;

}
    
//deconstructor
AggregatedDimension::~AggregatedDimension() 
{
    AggregatedHash::iterator it;
    it = hash.begin();
    while (it != hash.end())
    {
        delete (std::string *)(it->second.pointer);
        it ++;
    }
}
    
void AggregatedDimension::AddString(std::string str, double value)
{
    wxString wStr(str.c_str(), str.length());

    std::string *strPtr;
    strPtr = new std::string(str.c_str());

    hash[wStr] = PAV(strPtr, value);

    if (value >= max)
    {
        max = value;
        origMaxString = str;
        maxString = str;
    }
    if (value <= min)
    {
        min = value;
        origMinString = str;
        minString = str;
    }
}

/*
void AggregatedDimension::AddString(std::string str)
{
    currentValue += interval;
    AddString(str, currentValue);
}*/

double AggregatedDimension::GetValue(std::string str)
{
    wxString wStr(str.c_str(), str.length());
    return hash[wStr].value;
}


double AggregatedDimension::GetNorValue(std::string str)
{
    wxString wStr(str.c_str(), str.length());
    return Dimension::GetNorValue(hash[wStr].value);

    /*    AggregatedHash::iterator it;

    wxString wStr(str.c_str(), str.length());
    
    it = hash.find(wStr);
    GetNorValue(it->second.value);
    if (it == textHash.end())
    {
        GetNorValue(defaultValue);
    }
    else
    {
        GetNorValue(it->second.value);
    }*/
}

/*
double AggregatedDimension::GetNorValue(double value)
{
    if (min == max)
    {
        if (value == min)
            return 1;
        else
            return 0;
    }
    
    double v = (value - min) / (max - min);

    if (v < 0)
        v = 0;
    else if (v > 1)
        v = 1;

    return v;
}*/

void* AggregatedDimension::GetPointer(std::string str)
{
    AggregatedHash::iterator it;

    wxString wStr(str.c_str(), str.length());
    
    it = hash.find(wStr);
    if (it == hash.end())
    {
        AddString(str, max + interval);
        return hash[wStr].pointer;
    }
    else
    {
        return it->second.pointer;
    }
}


double AggregatedDimension::GetNorValue(Data data)
{
    std::string *ptr;
    ptr = (std::string *)data.p;
    return GetNorValue(*ptr);
}


void AggregatedDimension::GetNorValue(Data* data, double &norValue)
{
    norValue = GetNorValue(data[dimID]);
}

void AggregatedDimension::SetMinMaxString(std::string string1, std::string string2)
{
    double value1, value2;
    value1 = GetNorValue(string1);
    value2 = GetNorValue(string2);

    if (value1 < value2)
    {
        min = value1;
        minString = string1;

        max = value2;
        maxString = string2;
    }
    else
    {
        min = value2;
        minString = string2;

        max = value1;
        maxString = string1;
    }
}

void AggregatedDimension::GetLabels(std::string* &labels, double* &values, int &labelNum)
{
    double value, value0, value1;
    value0 = GetNorValue(minString);
    value1 = GetNorValue(maxString);
    
    labelNum = 2;

    AggregatedHash::iterator it;
    it = hash.begin();
    while (it != hash.end())
    {
        value = Dimension::GetNorValue(it->second.value);
        if (value > value0 && value < value1)
        {
            labelNum ++;
        }
        it++;
    }

    values = new double [labelNum];
    labels = new std::string [labelNum];

    labels[0] = minString;
    labels[1] = maxString;
    values[0] = value0;
    values[1] = value1;

    int i = 2;
    it = hash.begin();
    while (it != hash.end())
    {
        value = Dimension::GetNorValue(it->second.value);
        if (value > value0 && value < value1)
        {
            labels[i] = it->first.c_str();
            values[i] = value;
            i++;
        }
        it++;
    }
}

void AggregatedDimension::GetNorValueWithMinMax(Data* data, double &norValue, double &norMin, double &norMax)
{
    norValue = GetNorValue(data[dimID]);
}

void AggregatedDimension::GetNorValueWithMinMax(double value, double &norValue, double &norMin, double &norMax)
{
    norValue = Dimension::GetNorValue(value);
}


/*
void AggregatedDimension::GetLabels(std::string* &labels, double* &values, int &labelNum)
{
    labelNum = hash.size();
    labels = new std::string [labelNum];
    values = new double [labelNum];
    labels[0] = origMinString;
    labels[labelNum-1] = origMaxString;
    values[0] = GetNorValue(origMinString);
    values[labelNum-1] = GetNorValue(origMaxString);

    AggregatedHash::iterator it;
    it = hash.begin();
    int j = 1;
    for (int i = 0; i < labelNum; i++)
    {
        std::string str = it->first.c_str();
        if (str != origMinString && str != origMaxString)
        {
            labels[j] = str;
            values[j] = Dimension::GetNorValue(it->second.value);
        }
        it ++;
    }
}
*/

