#include "Cluster.h"

Cluster::Cluster(int dimNum)
{
    parent = NULL;

    this->dimNum = dimNum;
    isLeaf = true;
    entries = 0;
    sqrtRadius = 0;  //Stores the radius
    norPosition = 0;  //position of the cluster in the tree from 0 to 1 (for color assignment)
    flags = 0;
    level = 0;

    mean = new double [dimNum];
    max = NULL;
    min = NULL;
}

Cluster:: ~Cluster()
{
    if (mean != NULL)
        delete [] mean;
    if (max != NULL)
        delete [] max;
    if (min != NULL)
        delete [] min;
}

void Cluster::SetParent(Cluster* parent)
{
    this->parent = parent;
}

Cluster* Cluster::GetParent()
{
    return parent;
}

void Cluster::AddChild(Cluster* child)
{
    children.AddNodeAtEnd(child);
}

void Cluster::SetEntries(int entries)
{
    this->entries = entries;
    if (entries == 1)
        isLeaf = true;
    else
    {
        isLeaf = false;
        max = new double [dimNum];
        min = new double [dimNum];
    }
}

void Cluster::SetSqrtRadius(double sqrtRadius)
{
    this->sqrtRadius = sqrtRadius;
}

double Cluster::GetSqrtRadius()
{
    return sqrtRadius;
}

bool Cluster::IsLeaf()
{
    return isLeaf;
}

int Cluster::GetChildrenNum()
{
    return children.GetLength();
}

LinkListIterator* Cluster::IterateChildren()
{
	return new LinkListIterator(&children);
}

void Cluster::SetNorPosition(double pos)
{
    norPosition = pos;
}


double Cluster::GetNorPosition()
{
    return norPosition;
}

bool Cluster::IsMarked(int mark)
{
    return BITTEST(this->flags, mark);
}