#ifndef CLUSTER_H
#define CLUSTER_H

#define IS_CONTOUR_UNBRUSHED 1<<0
#define IS_CONTOUR_BRUSHED  1<<1
#define IS_MAGNIFIED 1<<2
#define IS_BRUSHED   1<<3
//#define IS_BRUSHED_ANY   1<<4

#include "../Basic/CLinkList.h"
#include "../Basic/LinkListIterator.h"
#include "../Basic/macros.h"

class LinkListIterator;

class Cluster 
{
public:
    int flags;

protected:
    Cluster* parent;//Reference to the parent in the cluster tree
    CLinkList children;

    int dimNum;
    bool isLeaf;
    int entries;
    double sqrtRadius; //Stores the radius
    double norPosition;  //position of the cluster in the tree from 0 to 1 (for color assignment)
    int level;

    double* max;
    double* min;
    double* mean;

public:
    Cluster(int dimNum);
    ~Cluster();

    void SetParent(Cluster* parent);
    Cluster* GetParent();
    void AddChild(Cluster* child);
    void SetEntries(int entries);
    void SetSqrtRadius(double sqrtRadius);
    double GetSqrtRadius();
    void SetNorPosition(double pos);
    double GetNorPosition();
    void SetLevel(int level) {this->level = level;}
    int GetLevel() {return level;}

    bool IsLeaf();

    void SetMean(int i, double mean) {this->mean[i] = mean;}
    void SetMax(int i, double max) {this->max[i] = max;}
    void SetMin(int i, double min) {this->min[i] = min;}

    double GetMean(int i) {return mean[i];}
    double GetMax(int i) {return max[i];}
    double GetMin(int i) {return min[i];}

    int GetChildrenNum();
    LinkListIterator* IterateChildren();

    bool IsMarked(int mark);
    int GetMark() {return flags;}

};


#endif
