#include "DBFlatDataSet.h"
#include "DBColumnIterator.h"
#include "DBRowIterator.h"

DBFlatDataSet::DBFlatDataSet(DBManager* dbManager) 
{
    FlatDataSet();
    this->dbManager = dbManager;
}


DBFlatDataSet::~DBFlatDataSet()
{
}


bool DBFlatDataSet::ReadData(std::ifstream* infile, DimensionSpace* allDimSpace, int itemNum, bool hasDescription)
{
    (*infile) >> dataTableName;
    (*infile) >> simiTableName;

    this->rowNum = itemNum;
    this->allDimSpace = allDimSpace;
    this->hasDescription = hasDescription;

    return true;
}


Iterator* DBFlatDataSet::LoadRows(DimensionSpace* dimSpace, Query* query, bool dimCluster, bool ordering, int outputMode, bool loadDescriptions, bool storeDescriptions)
{
//    loadDescriptions = true;
//    storeDescriptions = true;
//    descriptionHash.clear();
    return new DBRowIterator(dbManager, dataTableName, allDimSpace, dimSpace, 
                             rowNum, query, ordering, outputMode,
                             hasDescription && loadDescriptions, &descriptionHash, hasDescription && loadDescriptions && storeDescriptions);
 }

Iterator* DBFlatDataSet::LoadColumns(DimensionSpace *loadDimSpace, Query *query)
{
    return new DBColumnIterator(dbManager, dataTableName, allDimSpace, loadDimSpace, rowNum, query);
}

std::string DBFlatDataSet::GetItemDescription(int itemID)
{
    ISHash::iterator it;
    it = descriptionHash.find(itemID);
    if (it != descriptionHash.end())
    {
        return it->second;
    }
    else 
        return "";
}



/*

DBFlatDataIterator<FlatDataEntry*>* DBFlatDataSet::LoadUnbrushedData(bool extents)
{
	return (new DBFlatDataIterator(
        marks, -1, dataBuffer, coverages, dimManager, extents));
}


DBFlatDataIterator<FlatDataEntry*>* DBFlatDataSet::LoadBrushedData(int brushOperID, bool extents)
{
	return (new DBFlatDataIterator(
        marks, brushOperID, dataBuffer, coverages, dimManager, extents));
}


void DBFlatDataSet::ResetMarksAndCoverage()
{
    int i, j, brushOperNum; 
    Data* data;
    BrushOperation* brushOper;
    double coverage;

    brushOperNum = brushMananger->GetBrushOperationNumber();
    for (i = 0; i < numOfRows; i++)
    {
        marks[i] = -1;
        coverages[i] = 0;
        data = GetRow(i);
        if (dimManager->GetCurrentDimSpace()->ExceedsBoundary(data))
        {
            marks[i] = -2;
        }
        j = 0;
        while (marks[i] == -1 && j < brushOperNum)
        {
            brushOper = brushManager->GetBrushOperation(j);
            coverage = brushOper->GetCoverage(data);
            if (coverage > 1e10)
            {
                marks[i] = j;
                coverages[i] = coverage;
            }
        }
    }
}

int DBFlatDataSet::BrushOperCompAverage(int brushOperID, BrushOperation* brushOper, ARR<double> &averages)
{
    int count = 0;
    int i, j; 
    Data* data;
    double* norValues;

    for (i = 0; i < dimNum; i++)
        averages[i] = 0;

    bool covered;
    for (i = 0; i < numOfRows; i++)
    {
        covered = false;
        if (marks[i] == brushOperID)
            covered = true;
        else if (marks[i] >= 0 && marks[i] < brushOperID)
        {
            data = GetRow(i);
            if (brushOper->IsPointCovered(data))
                covered = true;
        }
        
        if (covered == true)
        {
            count ++;
      		dimManager->GetNormalizedData(data, norValues);
            for (j = 0; j < dimNum; j <0)
            {
                averages[j] += norValues;
            }
        }
    }

    for (i = 0; i < dimNum; i++)
        averages[i] /= count;

    return count;
}

*/