#ifndef DBFlatDataSet_H
#define DBFlatDataSet_H

#include <fstream>


#include "DBConnection/DBManager.h"
#include "DataStructure/FlatDataSet.h"
#include "DataStructure/DimensionSpace.h"
#include "../../basic/macros.h"
//#include "DBFlatDataIterator.h"

class DBFlatDataSet : public FlatDataSet
{
public: 
    std::string dataTableName;
    std::string simiTableName;
    DBManager* dbManager;
    DimensionSpace* allDimSpace;
    int rowNum;

    bool hasDescription;
    ISHash descriptionHash;

private:
    std::string str;
public: 
	DBFlatDataSet(DBManager* dbManager);
	~DBFlatDataSet();

//    DBFlatDataIterator<FlatDataEntry*>* LoadUnbrushedData(bool extents);
//    DBFlatDataIterator<FlatDataEntry*>* LoadBrushedData(int brushOperID, bool extents);
//    DBFlatDataIterator<FlatDataEntry*>* LoadData();
//    void ResetMarksAndCoverage();

    bool ReadData(std::ifstream* infile, DimensionSpace* allDimSpace, int itemNum, bool hasDescription);
    Iterator* LoadRows(DimensionSpace* dimSpace, Query* query, bool dimCluster, bool ordering, int outputMode, bool loadDescriptions, bool storeDescriptions);
    Iterator* LoadColumns(DimensionSpace* dimSpace, Query *query);
    std::string GetItemDescription(int itemID);
};



#endif

