#ifndef DB_ROW_ITERATOR_H
#define DB_ROW_ITERATOR_H

#include "Basic/Iterator.h"
#include "DataStructure/DocRow.h"
#include "DBConnection/DBManager.h"
#include "../Query.h"
#include "../../basic/macros.h"

class DBManager;

class DBRowIterator : public Iterator
{
protected:
    DBManager* dbManager;
    DimensionSpace* dimSpace;
    DimensionSpace* loadDimSpace; 
    bool sampling;
    std::string dataTableName;
    int samplingMode;
    int outputMode;
    bool isIncreasingOrder;

    int rowNum; 
    DocRow* docRow;
    int dimNum;
    int count;

    int orderbyDimID;
    
    ResultSet* re;
    Dimension** dims;
    bool hasDescription;
    ISHash *descriptionHash;
    bool storeDescriptionInHash;

    Query* query;

private:
    std::string dstr;

public:
    DBRowIterator(DBManager* dbManager, std::string dataTableName, DimensionSpace* allDimSpace, DimensionSpace* dimSpace, 
                             int rowNum, Query* query, bool ordering, int outputMode, bool hasDescription, ISHash *desciptionHash, 
                             bool storeDesciptionInHash);
    ~DBRowIterator();

    void* GetNext();
	bool IsDone();

protected:
    bool LoadData();
    int GetRowNumber(int approximateSize);
    int GetRandomSamplingRowNumber(int approximateSize);
};

#endif
