#ifndef _NumericSimilarityCalculator_H
#define _NumericSimilarityCalculator_H

#include<string>
#include "SimilarityCalculator.h"

class NumericSimilarityCalculator : public SimilarityCalculator
{
protected:
    int numBins;
    int numDataItems;
    int numBinRows;
    double** bins;
    double** similarityMatrix;

public:
	NumericSimilarityCalculator();
	NumericSimilarityCalculator(int numDimensions, int numBins);

	~NumericSimilarityCalculator();
	
    //update the calculator by added a data item
    bool Update(double* values);
    bool Calculate();

    //initiate the calculator
    bool init(int numDimensions, int numBins);    

    //calculate the simiarlity matrix 
    //threshold to handle outliers to be added
	void CalculateSimilarityMatrix(double threshold);
	void CalculateSimilarityMatrix2(double threshold);
	void CalculateSimilarityMatrix();
	void CalculateSimilarityMatrix2();
	void CalculateSimilarityMatrix3();
    double CalculateDistanceVariance();
    void SmoothDistanceMatrix();

    double CalculateDistanceVarianceAroundCenter(int centerID);
    void CalculateSimilarityMatrixAroundCenter(int centerID);
    bool CalculateAroundCenter(int centerID);

protected:
    int GetIndex(int i, int j);

};

#endif

