#include<string>
#include<math.h>
#include <fstream>
#include <sstream>
#include <fstream>

#include "SimilarityCalculator.h"

SimilarityCalculator :: SimilarityCalculator()
{
}


SimilarityCalculator :: ~SimilarityCalculator()
{
}


bool SimilarityCalculator :: WriteCovMatrix(std::string fileName)
{
    std::ofstream outfile(fileName.c_str());
    int i, j;

    outfile << numDims << " " << GetSortDimension() << std::endl;
    for (i = 0; i < numDims; i++)
    {
        for (j = i; j < numDims; j++)
        {
            outfile << similarityMatrix[i][j] << " ";
        }
        outfile << std::endl;
    }
    outfile.close();
    return true;
}


void SimilarityCalculator :: GetSimilarityMatrix(double **matrix)
{
    int i, j;

    for (i = 0; i < numDims; i++)
    {
        for (j = i; j < numDims; j++)
        {
            matrix[i][j] = matrix[j][i] = similarityMatrix[i][j];
        }
    }
}


int SimilarityCalculator :: GetSortDimension()
{
    int i, j;

    int sort_dim = -1;
    double min_total = 1000000;
    for (i = 0; i < numDims; i++)
    {
        double total = 0;
        for (j = 0; j < numDims; j++)
        {
            total += similarityMatrix[i][j];
        }

        if (total < min_total)
        {
            sort_dim = i;
            min_total = total;
        }
    }

    return sort_dim;
}

