#include <FLOAT.h>
#include <string>
#include <fstream>
#include <stdio.h>

#include "DateDimension.h"


//constructor
DateDimension::DateDimension() 
{
    type = DATE_DIMENSION;
    max = -1;
    min = 0;
    firstDate.ParseDate("11/11/1911");
    lastDate.ParseDate("11/11/1911");
}
    
//deconstructor
DateDimension::~DateDimension() 
{
}
    
double DateDimension::GetNorValue(std::string valueString)
{
    double days = GetValue(valueString);
    return (days - min) / (max - min);
}

double DateDimension::GetValue(std::string valueString)
{
    wxDateTime thisDate;
    thisDate.ParseDate(valueString.c_str());
    int days = thisDate.Subtract(firstDate).GetDays();
    return days;
}

/*
void DateDimension::SetCardinality(int cardinality)
{
    if (cardinality < 1)
        cardinality = 1;
    this->cardinality = cardinality;
    
    if (cardValues != NULL)
        delete [] cardValues;

    cardValues = new wxDateTime[cardinality + 1];

    cardValues[0] = firstDate;
    int days = lastDate.Subtract(firstDate).GetDays();
    days /= cardinality;
    wxTimeSpan interval = wxTimespan::Days(days);

    for (int i = 1; i < cardinality; i++)
    {
        cardValues[i] = cardValues[i-1].Add(interval);
    }
    cardValues[cardinality] = lastDate;
}*/

void DateDimension::GetLabels(std::string* &labels, double* &values, int &labelNum)
{
    labelNum = cardinality + 1;
    labels = new std::string [labelNum];
    values = new double [labelNum];

    labels[0] = origMinString;
    labels[1] = origMaxString;

    int tempMin = lastDate.Subtract(firstDate).GetDays();
    for (int i = 2; i < labelNum; i++)
    {   
        wxDateTime temp = firstDate;
        labels[i] = temp.Add(wxTimeSpan::Days((cardValues[i-1]*(max - min) + min))). FormatDate();
    }

    for (i = 0; i < labelNum; i++)
    {
        values[i] = GetNorValue(labels[i]);
    }
}

void DateDimension::SetOriginalMaximumString(std::string maxString) 
{
    origMaxString = maxString;
    lastDate.ParseDate(origMaxString.c_str());

    min = 0;
    max = lastDate.Subtract(firstDate).GetDays();

}
    
void DateDimension::SetOriginalMinimumString(std::string minString) {
    origMinString = minString;
    firstDate.ParseDate(origMinString.c_str());

    min = 0;
    max = lastDate.Subtract(firstDate).GetDays();
}


void DateDimension::ReadMetaInformation(std::ifstream *infile)
{
    char buf[2000];
	std::string str;
	
	(*infile) >> buf;
	str = buf;

    if (str.compare("*") == 0)
    {
        mappingUncertain = true;
	    SetCardinality(5);
    }
    else
    {
        mappingUncertain = false;

	    SetOriginalMinimumString(str);

	    (*infile) >> buf;
	    str = buf;
	    SetOriginalMaximumString(str);

	    int card;
	    (*infile) >> card;
	    SetCardinality(card);
    }
    (*infile).getline(buf, 2000);
}

void DateDimension::ChangeMinMax(std::string valueString)
{
    wxDateTime thisDate;
    thisDate.ParseDate(valueString.c_str());

    if (thisDate.IsEarlierThan(firstDate))
    {
        firstDate = thisDate;
        origMinString = valueString;
    }
    if (thisDate.IsLaterThan(lastDate))
    {
        lastDate = thisDate;
        origMaxString = valueString;
    }

    min = 0;
    max = lastDate.Subtract(firstDate).GetDays();
}

double DateDimension::GetNorValue(Data data)
{
    std::string *ptr;
    ptr = (std::string *)data.p;
    return GetNorValue(*ptr);
}
