//Here, Bin means a Bin in a high dimensional space

#ifndef DocBin_H
#define DocBin_H

#include "DocElement.h"
#include "DimensionSpace.h"

class DocBin : public DocElement
{
protected:
    bool notLoad; //if notLoad is true, then the data stored is meaningless and should not be used

	int* indexes;
	int id;
    int count;
    int total_count;

    DimensionSpace* dimSpace;

    double xPos, yPos, xSize, ySize;

    int binNum;

public: 
    DocBin(DimensionSpace* dimSpace);
	~DocBin();

   void SetIndex(int dim, int index) {indexes[dim] = index;}
//   void SetIndex(int index) {this->index = index;}
	int* GetIndexes() {return indexes;}
    void SetBinID(int id) {this->id = id;}
    int GetBinID() {return id;}

    void SetCount(int count){this->count = count;}
    int GetCount(){return count;}

    void SetNotLoad(bool notLoad) {this->notLoad = notLoad;}
    bool GetNotLoad() {return notLoad;}

    void SetTotalCount(int count) {total_count = count;}
    int GetTotalCount() {return total_count;}

    DimensionSpace* GetDimensionSpace() {return dimSpace;}

    void SetXPosition(double xPos) {this->xPos = xPos;}
    void SetYPosition(double yPos) {this->yPos = yPos;}
    void SetXSize(double xSize) {this->xSize = xSize;}
    void SetYSize(double ySize) {this->ySize = ySize;}
    double GetXPosition() {return xPos;}
    double GetYPosition() {return yPos;}
    double GetXSize() {return xSize;}
    double GetYSize() {return ySize;}

    int GetBinNumber() {return binNum;}
    void SetBinNumber(int binNum) {this->binNum = binNum;}
};




#endif

