//Here, Column means a column in a table, namely a dimension. 


#include "DocColumn.h"

DocColumn::DocColumn()
{
    data = NULL;
    baseData = NULL;
    xData = NULL;
    yData = NULL;
    itemIDs = NULL;
    maskData = NULL;
    size = 0;
    mode = SINGLE;
    maskMode = false;
}

DocColumn:: ~DocColumn()
{
    if (data != NULL)
        delete [] data;
    if (baseData != NULL)
        delete [] baseData;
    if (xData != NULL)
        delete [] xData;
    if (yData != NULL)
        delete [] yData;
    if (maskData != NULL)
        delete [] maskData;
    if (itemIDs!= NULL)
        delete [] itemIDs;
}

//if size > 0, reture true, else, false
//after setsize, the data array can either be NULL or initiated to the desired size
//the reason it can be NULL is that in the case the data is not used, I don't want to 
//initiated it since size can be a huge number. Save some momory :)
bool DocColumn::SetSize(int size)
{
    if (size <= 0)
        return false;

    if (this->size == size)
        return true;
    
    //if new size != old size, then the data array need to be deleted, since it will be different from the old one)
    if (data != NULL)
    {
        delete [] data;
        data = NULL;
    }

    if (baseData != NULL)
    {
        delete [] baseData;
        baseData = NULL;
    }
    if (xData != NULL)
    {
        delete [] xData;
        xData = NULL;
    }
    if (yData != NULL)
    {
        delete [] yData;
        yData = NULL;
    }

    if (maskData != NULL)
    {
        delete [] maskData;
        maskData = NULL;
    }
    
    if (itemIDs != NULL)
    {
        delete [] itemIDs;
        itemIDs = NULL;
    }
    
    this->size = size;

    return true;
}

void DocColumn::SetNotLoad(bool notLoad)
{
    this->notLoad = notLoad;
}

//for efficiency, I assume that size is > 0, and i is <= size and > 0
void DocColumn::SetData(int i, double value)
{
    if (data == NULL)
        data = new float [size];

    data[i] = value;
}

//for efficiency, I assume that size is > 0, and i is <= size and > 0
void DocColumn::SetBaseData(int i, double value)
{
    if (baseData == NULL)
        baseData = new float [size];

    baseData[i] = value;
}

void DocColumn::SetXData(int i, double value)
{
    if (xData == NULL)
        xData = new float [size];

    xData[i] = value;
}

void DocColumn::SetYData(int i, double value)
{
    if (yData == NULL)
        yData = new float [size];

    yData[i] = value;
}

void DocColumn::SetItemID(int i, int id)
{
    if (itemIDs == NULL)
        itemIDs = new int [size];

    itemIDs[i] = id;
}

int* DocColumn::GetItemIDs()
{
    return itemIDs;
}

void DocColumn::SetMaskData(int i, double value)
{
    if (maskData == NULL)
        maskData = new float [size];

    maskData[i] = value;
}

float* DocColumn::GetData()
{
    return data;
}

float* DocColumn::GetBaseData()
{
    return baseData;
}
float* DocColumn::GetXData()
{
    return xData;
}
float* DocColumn::GetYData()
{
    return yData;
}

float* DocColumn::GetMaskData()
{
    return maskData;
}

int DocColumn::GetSize()
{
    return size;
}

bool DocColumn::NotLoad()
{
    return notLoad;
}

int DocColumn::GetMode()
{
    return mode;
}