#include <FLOAT.h>
#include <string>
#include <fstream>

#include "DoubleDimension.h"


//constructor
DoubleDimension::DoubleDimension() 
{
    type = DOUBLE_DIMENSION;
    max = -DBL_MAX;
    min = DBL_MAX;
    origMaxString = "";
    origMinString = "";
//    cardValues = NULL;
}
    
//deconstructor
DoubleDimension::~DoubleDimension() 
{
//    if (cardValues != NULL)
  //      delete [] cardValues;
}
    
/**
 * Sets the maximum value of this dimension.  
 * @param maxString the std::string that contains the maximum value
 */
void DoubleDimension::SetOriginalMaximumString(std::string maxString) {
    this->origMaxString = maxString;
    this->maxString = maxString;
    max = atof(maxString.c_str());
//    if (max <= min)
//        max = min;
}
    
/**
 * Sets the minimum value of this dimension.  
 * @param minString the std::string that contains the minimum value
 */
void DoubleDimension::SetOriginalMinimumString(std::string minString) {
    this->origMinString = minString;
    this->minString = minString;
    min = atof(minString.c_str());
//    if (min >= max)
//        min = max;
}

double DoubleDimension::GetValue(std::string valueString)
{
    return atof(valueString.c_str());
}




/**
 * Adds a rim to this dimension so that the real range of this 
 * dimension is a little bit larger that the input range  
 */
/*void DoubleDimension::AddRim() {
    double rim = (max - min)/20;
    if (rim == 0)
        rim = 0.1;
    max = max + rim;
    min = min - rim;
}*/
    
/**
 * Gets a message contains the dimension name and a data value.  
 * @param norValue the normalized value of the data
 */
/*bool DoubleDimension::GetNamedValueMessage(double norValue, char* buffer, int buffer_length, int& msg_length) 
{
	
    

	return name + " = " + getValueMessage(norValue);
}
*/
/**
 * Gets a message contains a data value.  
 * @param norValue the normalized value of the data
 */
/*String DoubleDimension::GetValueMessage(double norValue) {
    double value = norValue * (max - min) + min;
    return "" + new Double(value).floatValue();
}*/

/**
 * Gets the normalized value of a data.  
 * @param valueString the data in a std::string
 */
/*double DoubleDimension::GetNorValue(std::string valueString) {
    double value = atof(valueString.c_str());

    if (mappingUncertain)
    {
        if (value > max)
        {
            max = value;
            origMaxString = valueString;
        }
        if (value < min)
        {
            min = value;
            origMinString = valueString;
        }
    }

    if (min == max)
    {
        if (value == min)
            return 1;
        else
            return 0;
    }
    
    double v = (value - min) / (max - min);

    if (v < 0)
        v = 0;
    else if (v > 1)
        v = 1;

    return v;
}*/

double DoubleDimension::GetNorValue(std::string valueString) 
{
    double value = atof(valueString.c_str());

    if (min == max)
    {
        if (value == min)
            return 1;
        else
            return 0;
    }
    
    double v = (value - min) / (max - min);

    if (v < 0)
        v = 0;
    else if (v > 1)
        v = 1;

    return v;
}


void DoubleDimension::ChangeMinMax(std::string valueString)
{
    double value = atof(valueString.c_str());

    if (value > max)
    {
        max = value;
        origMaxString = valueString;
    }
    if (value < min)
    {
        min = value;
        origMinString = valueString;
    }
}


double DoubleDimension::GetNorValue(Data data) 
{
    double value = data.d;
    return Dimension::GetNorValue(value);
}

void DoubleDimension::GetNorValueWithMinMax(Data* data, double &norValue, double &norMin, double &norMax)
{
    norValue = GetNorValue(data[dimID]);
}

void DoubleDimension::GetNorValueWithMinMax(double value, double &norValue, double &norMin, double &norMax)
{
    norValue = Dimension::GetNorValue(value);
}

void DoubleDimension::GetLabels(std::string* &labels, double* &values, int &labelNum)
{
    labelNum = 2;
    labels = new std::string [labelNum];
    values = new double [labelNum];

    labels[0] = minString;
    labels[1] = maxString;

    for (int i = 0; i < labelNum; i++)
    {
        values[i] = GetNorValue(labels[i]);
    }
}

void DoubleDimension::ReadMetaInformation(std::ifstream *infile)
{
    char buf[2000];
	std::string str;
	
	(*infile) >> buf;
	str = buf;

    if (str.compare("*") == 0)
    {
        mappingUncertain = true;
	    SetCardinality(5);
    }
    else
    {
        mappingUncertain = false;

	    SetOriginalMinimumString(str);

	    (*infile) >> buf;
	    str = buf;
	    SetOriginalMaximumString(str);

	    int card;
	    (*infile) >> card;
	    SetCardinality(card);
    }
    (*infile).getline(buf, 2000);
}
