#include "InMemoryFlatRowIterator.h"


InMemoryFlatRowIterator::InMemoryFlatRowIterator(
	DataBuffer* dataBuffer, DimensionSpace* dimSpace, bool dimCluster, int outputMode)
{
	this->dataBuffer = dataBuffer;
	this->dimSpace = dimSpace;
    this->outputMode = outputMode;

	dataSize = dataBuffer->GetRowNum();
	nextPosition = GetNextPosition(-1);
    docData = new DocRow(dimSpace, false, dimCluster);
}	

InMemoryFlatRowIterator:: ~InMemoryFlatRowIterator()
{
	delete docData;
}

int InMemoryFlatRowIterator::GetNextPosition(int oldPosition)
{
	int pos;
	pos = oldPosition + 1;
//	while (pos < dataSize && !(brushOper->IsPointCovered(dataBuffer->GetRow(pos))))
//	while (pos < dataSize)
//		pos ++;

    return pos;
}


void* InMemoryFlatRowIterator::GetNext()
{
	if (nextPosition >= dataSize)
		return NULL;

	Data* data = dataBuffer->GetRow(nextPosition);

    if (outputMode == ROW_NORVALUEONLY)
        docData->ResetData(data);
    else if (outputMode == ROW_CARDONLY)
        docData->ResetCards(data);
//	flatDataEntry->SetID(nextPosition);
//	flatDataEntry->SetCoverage(brushOper->GetCovereage(data));

    nextPosition = GetNextPosition(nextPosition);
	return docData;
}


bool InMemoryFlatRowIterator::IsDone()
{
	if (nextPosition >= dataSize)
		return true;
	else
		return false;
}


