#ifndef InMemoryHierDataSet_H
#define InMemoryHierDataSet_H

#include <fstream>

#include "DataStructure/HierDataSet.h"
#include "DataStructure/DimensionSpace.h"
#include "Basic/macros.h"
#include "DataStructure/SBBrush.h"
//#include "InMemoryHierDataIterator.h"

class InMemoryHierDataSet : public HierDataSet
{
public: 
    Cluster** clusters;
    Cluster* root;

    int dimNum;
    int nodeNum;
    int leafNodeNum;

public: 
	InMemoryHierDataSet();
	~InMemoryHierDataSet();

    bool ReadData(std::string fname, DimensionSpace* dimSpace);
    void AssignPositions(Cluster* node, double L, double R);

    void MarkBrushedClusters(SBBrush *brush);
//    void MarkBrushedClusters();
    void MarkContourClusters(double contour_radius, int FLAG);
    double GetRootSqrtRadius();

    Iterator* LoadData(DimensionSpace* dimSpace, bool dimCluster, bool showBand, bool brushed);
    void GetLeafSBBContour(int &num, SBBContourNode* &nodes);
    void GetSBBContour(bool brushed, int &num, SBBContourNode* &nodes);

protected:
    bool ReadNormalData(std::string fname, DimensionSpace* dimSpace);
    bool ReadBinaryData(std::string fname, DimensionSpace* dimSpace);

    void MarkBrushedClusters(Cluster* node);

};



#endif

