#include "InMemoryHierRowIterator.h"


InMemoryHierRowIterator::InMemoryHierRowIterator(
	Cluster** clusters, int nodeNum, DimensionSpace* dimSpace, bool dimCluster, 
    bool showBand, bool brushed)
{
    this->clusters = clusters;
    this->nodeNum = nodeNum;
    this->brushed = brushed;

    this->dimSpace = dimSpace;
	nextPosition = GetNextPosition(-1);
    docData = new DocRow(dimSpace, showBand, dimCluster);
}	

InMemoryHierRowIterator:: ~InMemoryHierRowIterator()
{
	delete docData;
}

bool InMemoryHierRowIterator::Selected(Cluster* cluster)
{
    int flags = cluster->GetMark();
    if (brushed)
    {
        if (BITTEST(flags, IS_CONTOUR_BRUSHED) && BITTEST(flags, IS_BRUSHED))
            return true;
        else
            return false;
    }
    else
    {
        if (BITTEST(flags, IS_CONTOUR_UNBRUSHED) && !BITTEST(flags, IS_BRUSHED))
            return true;
        else
            return false;
    }
}

int InMemoryHierRowIterator::GetNextPosition(int oldPosition)
{
	int pos;
	pos = oldPosition + 1;
    while (pos < nodeNum && !Selected(clusters[pos]))
        pos ++;

    return pos;
}


void* InMemoryHierRowIterator::GetNext()
{
	if (nextPosition >= nodeNum)
		return NULL;

    docData->ResetData(clusters[nextPosition]);

    nextPosition = GetNextPosition(nextPosition);
	return docData;
}


bool InMemoryHierRowIterator::IsDone()
{
	if (nextPosition >= nodeNum)
		return true;
	else
		return false;
}


