#ifndef _IN_MEMORY_HIER_DATA_ITERATOR_H
#define _IN_MEMORY_HIER_DATA_ITERATOR_H

#include "Basic/Iterator.h"
#include "Basic/macros.h"
#include "DataStructure/DocRow.h"
#include "DataStructure/Cluster.h"

class Cluster;
class DimensionManager;

class InMemoryHierRowIterator : public Iterator
{
protected:
    Cluster** clusters;
    int nodeNum;
    bool brushed;
    int nextPosition;
	DimensionSpace* dimSpace;

    int dimNum;
    DocRow* docData;

public:
    InMemoryHierRowIterator(Cluster** clusters, int nodeNum, DimensionSpace* dimSpace, bool dimCluster, 
    bool showBand, bool brushed);

	void* GetNext();

	bool IsDone();

	~InMemoryHierRowIterator();

protected:
    int GetNextPosition(int oldPosition);
    bool Selected(Cluster* cluster);
};

#endif
