#include <sstream>
#include "ItemNameIterator.h"
#include "DocRow.h"


ItemNameIterator::ItemNameIterator(Iterator* rowIter)
{
	this->rowIter = rowIter;

    docLabel= new DocLabel();
    docLabel->SetNorValue(1.);
}	

ItemNameIterator:: ~ItemNameIterator()
{
	delete docLabel;
    delete rowIter;
}

void* ItemNameIterator::GetNext()
{
    DocRow* row = (DocRow*)(rowIter->GetNext());
    docLabel->SetText(row->GetItemDescription());
    docLabel->SetDimensionID(row->GetItemID());
	return docLabel;
}


bool ItemNameIterator::IsDone()
{
    return rowIter->IsDone();
}


