#ifndef SBBrush_H
#define SBBrush_H

#include "Cluster.h"
#define POSITION_BRUSH 0
#define EXTENT_BRUSH 1
#define BRUSH_ALL 0
#define BRUSH_ANY 1

#include "HierDataSet.h"

class HierDataSet;

class SBBrush 
{
public:
    //level of detail control
    double unbrushedRadius;
    double brushedRadius;

    int brushType;  //brush by position or extent
    int semantic;  //BRUSH_ALL or BRUSH_ANY
    
    //brush range control for brush by position
    double brushedRegionL;
    double brushedRegionR;

    //brush range control for brush by extent
    //FlatBrush* brush;

    HierDataSet* dataset;

public:
    SBBrush();
    ~SBBrush();

    void SetHierDataSet(HierDataSet* dataset);
    void SetBrushedRegionL(double L);
    void SetBrushedRegionR(double R);
    void ShiftBrushedRegion(double shift);

    void SetUnbrushedRadius(double radius);
    void SetBrushedRadius(double radius);

    bool IsClusterCovered(Cluster* cluster);

    int GetSemantic();
    void SetSemantic(int semantic);
//    void SetBrushType();
    double GetBrushedRegionL() {return brushedRegionL;}
    double GetBrushedRegionR() {return brushedRegionR;}
    double GetUnbrushedRadius() {return unbrushedRadius;}
    double GetBrushedRadius() {return brushedRadius;}


};


#endif
