#ifndef _Dimstack_VISUAL_Bin_META_H
#define _Dimstack_VISUAL_Bin_META_H

#include "../VisualBinMeta.h"
#include "DimstackDrawer.h"
#include "DimstackVisualAxes.h"
#include "../VisualElementsIterator.h"
#include "DimstackVisualBin.h"
#include "../../DataStructure/DocBin.h"

class VisualElementsIterator;
class DimstackDrawer;

class DimstackVisualBinMeta : public VisualBinMeta 
{
protected:
    Layer* axesLayer;
    VisualElementsIterator *visAxesIter;
    VisualElementMeta *axesMeta;
    Iterator *axesIter; 

    DimstackDrawer* drawer;
    DimstackVisualAxes *axes;
    ColorManager* colorManager;

    grCanvas* canvas;

    int* pos;
    int w, h;
    float* colorData;
    
    int DimstackStyle;

    int focusItem;

    GLuint maskTexture;

    int dimBinSize;
    int dimBinInterval;
    int dimBinSolid;
    int dimNum;
    int hNum;
    int wNum;
    float aveCount;

public:
    DimstackVisualBinMeta();
	DimstackVisualBinMeta(DimstackDrawer* drawer, 
        DocumentManager* docManager, bool brushed);
	~DimstackVisualBinMeta();

    VisualElement* InstantVisualElement();
    void Convert(VisualElement* visualEle, DocElement* docEle);

protected:
    void GetBitMap(DocBin* docBin, int &w, int &h, float*& colorData);
    void PrepareBitMapColorData(DocBin *docBin);


};

#endif

