#ifndef _PARCOORD_VISUAL_DATA_META_H
#define _PARCOORD_VISUAL_DATA_META_H

#include "../VisualRowMeta.h"
#include "ParcoordDrawer.h"
#include "ParcoordVisualAxes.h"
#include "../VisualElementsIterator.h"

class VisualElementsIterator;
class ParcoordDrawer;

class ParcoordVisualRowMeta : public VisualRowMeta 
{
protected:
    Layer* axesLayer;
    VisualElementsIterator *visAxesIter;
    VisualElementMeta *axesMeta;
    Iterator *axesIter; 

    ParcoordDrawer* drawer;
    ParcoordVisualAxes *axes;
    bool omitColor;

    ColorSetting* colorSetting;
    ColorSetting* bandColorSetting;
    
public:
    ParcoordVisualRowMeta();
	ParcoordVisualRowMeta(ParcoordDrawer* drawer, 
        DocumentManager* docManager, bool brushed, bool hier);
	~ParcoordVisualRowMeta();

    VisualElement* InstantVisualElement();
    void Convert(VisualElement* visualEle, DocElement* docEle);
};

#endif

