#include "ParcoordVisualRulerMeta.h"
#include "../VisualRuler.h"
#include "../../DataStructure/DocLabel.h"
#include "../../MainApplication.h"

ParcoordVisualRulerMeta::ParcoordVisualRulerMeta(ParcoordDrawer* drawer, DocumentManager* docManager, RGBt color, float length)
{
    this->drawer = drawer;

    axesLayer = new Layer(AXES);
    axesMeta = axesLayer->CreateVisualElementMeta(drawer, docManager);
    axesIter = docManager->GetElementsIterator(AXES, axesMeta);
    visAxesIter  = new VisualElementsIterator(axesMeta, axesIter); 
    
    axes = (ParcoordVisualAxes *)(visAxesIter->GetNext());

    this->color = color;
    this->length = length;
}

ParcoordVisualRulerMeta::~ParcoordVisualRulerMeta()
{
    delete axesLayer;
    delete visAxesIter;
    delete axesMeta;
    delete axesIter; 
}

VisualElement* ParcoordVisualRulerMeta::InstantVisualElement()
{
    VisualRuler* visRuler= new VisualRuler();
    
    visRuler->SetColor(color);
    return visRuler;
}

void ParcoordVisualRulerMeta::Convert(VisualElement* visualEle, DocElement* docEle)
{
    VisualRuler* visualRuler = (VisualRuler *)visualEle;
    DocLabel* docLabel= (DocLabel *)docEle;

    visualRuler->SetX1(axes->GetDimensionPosition(docLabel->GetDimensionID()));
    visualRuler->SetY1(docLabel->GetNorValue());
    visualRuler->SetX2(visualRuler->GetX1() + length);
    visualRuler->SetY2(visualRuler->GetY1());

//    visualLabel->SetColor();  we can allow different colors for labels , if we add this function.
}