#include "VarVisualAxesMeta.h"
#include "VarVisualAxes.h"
#include "../../DataStructure/DocAxes.h"
#include "../../MainApplication.h"
#include "VarDrawerSettings.h"

VarVisualAxesMeta::VarVisualAxesMeta(VarDrawer* drawer)
{
    this->drawer = drawer;
	
    settings = (VarDrawerSettings *)drawer->GetSettings();

    dimXYFromDataSet = settings->IsXYFromDataSet();
}

VarVisualAxesMeta::~VarVisualAxesMeta()
{
}


VisualElement* VarVisualAxesMeta::InstantVisualElement()
{
    VarVisualAxes* visAxes = new VarVisualAxes();
    
    return visAxes;
}

void VarVisualAxesMeta::Convert(VisualElement* visualEle, DocElement* docEle)
{
    VarVisualAxes* visualAxes = (VarVisualAxes *)visualEle;
    DocAxes* docAxes = (DocAxes *)docEle;

    if (settings->IsXYFromDataSet())
    {
        Vec2* p;
        IPHash* xyHash = docAxes->GetDimensionXYPosHash();
        IPHash::iterator it;
        for( it = xyHash->begin(); it != xyHash->end(); ++it )
        {
            p = (Vec2*)(it->second);
            settings->SetTextureXYPosition(it->first, p->X, p->Y);
        }
        settings->SetXYFromDataSet(false);
    }
    settings->SetSelectedTextureHash(docAxes->GetSelectedDimensionHash());
    settings->SetLabelHash(docAxes->GetLabelDimensionHash());
    visualAxes->SetSettings(settings);

/*
    int dimNum = docAxes->GetDimenionNum();
    visualAxes->SetDimensionNum(dimNum);

//    int activeDimID = docAxes->GetActiveDimensionID();
//    visualAxes->SetActiveDimensionID(activeDimID);

    int i;
	int dimID;
	float centerx, centery;
    for (i = 0; i < dimNum; i++)
    {
    	dimID = docAxes->GetDimensionID(i);
//        visualAxes->SetDimensionID(i, dimID);

        settings->GetTextureXYSize(dimID, xSize, ySize);
        visualAxes->SetXSize(i, xSize);
        visualAxes->SetYSize(i, ySize);

        if (dimXYFromDataSet)
        {
            Vec2 p;
            p = docAxes->GetDimensionXYPosition(i);
		    centerx = p.X;
		    centery = p.Y;
		    
            settings->SetTextureXYPosition(dimID, centerx, centery);
        }
        else
        {
            settings->GetTextureXYPosition(dimID, centerx, centery);
        }

        if (centerx-xSize< 0)
            centerx = xSize;
        if (centerx+xSize> 1)
            centerx = 1-xSize;
        if (centery-ySize < 0)
            centery = ySize;
        if (centery+ySize > 1)
            centery = 1-ySize;

        visualAxes->SetXPosition(i, centerx);
        visualAxes->SetYPosition(i, centery);
    }
    
    if (dimXYFromDataSet)
        settings->SetXYFromDataSet(false);

    settings->SetSelectedItemHash(docAxes->GetSelectedItemHash());
*/
/*	VarDrawerSettings* settings = (VarDrawerSettings *)drawer->GetSettings();
	bool distortion = settings->IsDistortionEnabled();
	
	if (distortion)
	{
		float dis_factor = settings->GetDistortionFactor();
		float disXSize = dis_factor * xSize;
		float disYSize = dis_factor * ySize;
		for (i = 0; i < dimNum; i++)
		{
			dimID = docAxes->GetDimensionID(i);
			if (settings->IsDimensionDistorted(dimID))
			{
				visualAxes->SetXSize(i, disXSize);
				visualAxes->SetYSize(i, disYSize);
			}
			else
			{
				visualAxes->SetXSize(i, xSize);
				visualAxes->SetYSize(i, ySize);
			}
		}
	}
	else
	{*/

}