#ifndef _Var_VISUAL_Column_H
#define _Var_VISUAL_Column_H

#include "../VisualColumn.h"

class VarVisualColumn : public VisualColumn
{
public:
	GLuint texture;
	GLuint maskTexture;
	int width;
	int height;
	float xPos;
	float yPos;
	float xSize;
	float ySize;

    bool maskMode;

    int dimID;

    float zPos;

public:
	VarVisualColumn();
	~VarVisualColumn();

    void SetTexture(GLuint texture);
    void SetMaskTexture(GLuint texture);
    void SetWidth(int width);        //width: the width of the original texture object
    void SetHeight(int height);      //height: the height of the origianl texture object
    
    void SetXPosition(float x);
    void SetYPosition(float y);
    void SetZPosition(float z);

    void SetXSize(float x);
    void SetYSize(float y);

	GLuint GetTexture();
	GLuint GetMaskTexture();
	int GetWidth();        
	int GetHeight();      
	float GetXPosition();
	float GetYPosition();
	float GetZPosition();
	float GetXSize();
	float GetYSize();

    void SetMaskMode(bool mode) {maskMode = mode;}
    bool GetMaskMode() {return maskMode;}

    void SetDimensionID(int id) {dimID = id;}
    int GetDimensionID() {return dimID;}

};

#endif

