#ifndef _Var_VISUAL_Column_META_H
#define _Var_VISUAL_Column_META_H

#include "../VisualColumnMeta.h"
#include "VarDrawer.h"
#include "VarVisualAxes.h"
#include "../VisualElementsIterator.h"
#include "../../Color/ColorSetting.h"
#include "../../Basic/macros.h"

class VisualElementsIterator;
class VarDrawer;

class VarVisualColumnMeta : public VisualColumnMeta 
{
protected:
    Layer* axesLayer;
    VisualElementsIterator *visAxesIter;
    VisualElementMeta *axesMeta;
    Iterator *axesIter; 

    VarDrawer* drawer;
    VarVisualAxes *axes;

	ColorSetting* colorSetting;

    grCanvas* canvas;
    int count;

    int* pos;
    int w, h;
    float* colorData;
    
    int glyphStyle;

    GLuint maskTexture;

    VarDrawerSettings* settings;

    bool binaryMode;

    IIHash* selectedItemHash;

public:
    VarVisualColumnMeta() {}
	VarVisualColumnMeta(VarDrawer* drawer, 
        DocumentManager* docManager, bool brushed, bool hier);
	~VarVisualColumnMeta();

    void GetVisualElement(VisualElement* visEle, int dimID); 
    VisualElement* InstantVisualElement();
    void Convert(VisualElement* visualEle, DocElement* docEle);

protected:
    //size: the length of array "data", data: the column data;
    //pos: the bitmap to be generated. It will be used in the texture object.
    void GetBitMapWithSingleDimensionInNonBinaryMode(int size, float* data, int* itemIDs);
    void GetBitMapWithSingleDimensionInBinaryMode(int size, float* data, int* itemIDs);
    void GetBitMapWithTwoDimension(int size, float* data, float* baseData);
    void GetBitMapWithTwoDimension2(int size, float* data, float* baseData);
    void GetBitMapWithThreeDimension(int size, float* data, float* xData, float* yData);
    void GetBitMapForMask(int size, float* maskData);

    void GetSpiralPositions(int size, int* pos, int &w, int &h);
    void GetVerticalPositions(int size, int* pos, int &w, int &h);
    void GetHCurvePositions(int size, int* pos, int &w, int &h);
    void GetHorizontalPositions(int size, int* pos, int &w, int &h);


private:
    void Hilbert(int size, int *pos, int &i, int w, int h, 
                                  int x0, int y0, int xis, int xjs, int yis, int yjs, int n);


};

#endif

