#ifndef _VAR_VISUAL_LABEL_META_H
#define _VAR_VISUAL_LABEL_META_H

#include "../VisualElementMeta.h"
#include "VarDrawer.h"
#include "VarVisualAxes.h"
#include "../VisualElementsIterator.h"

class VisualElementsIterator;
class VarDrawer;

class VarVisualLabelMeta : public VisualElementMeta 
{
protected:
    Layer* axesLayer;
    VisualElementsIterator *visAxesIter;
    VisualElementMeta *axesMeta;
    Iterator *axesIter; 

    VarDrawer* drawer;
    VarVisualAxes *axes;
    
    float angle;
    float scale;
    float shiftX;
    float shiftY;
    float minShiftX;
    float minShiftY;

public:
    VarVisualLabelMeta();
	VarVisualLabelMeta(VarDrawer* drawer, DocumentManager* docManager, 
        float angle, float scale, float shiftX, float shiftY,
        float minShiftX, float minShiftY);
	~VarVisualLabelMeta();

    VisualElement* InstantVisualElement();
    void Convert(VisualElement* visualEle, DocElement* docEle);
};

#endif

