#ifndef _Var_VISUAL_TimeHistogram_META_H
#define _Var_VISUAL_TimeHistogram_META_H

#include "../VisualTimeHistogramMeta.h"
#include "VarDrawer.h"
#include "VarVisualAxes.h"
#include "../VisualElementsIterator.h"
#include "../../Color/ColorSetting.h"

class VisualElementsIterator;
class VarDrawer;

class VarVisualTimeHistogramMeta : public VisualTimeHistogramMeta 
{
protected:
    Layer* axesLayer;
    VisualElementsIterator *visAxesIter;
    VisualElementMeta *axesMeta;
    Iterator *axesIter; 

    VarDrawer* drawer;
    VarVisualAxes *axes;

	ColorSetting* colorSetting;

    grCanvas* canvas;
    int count;

    int w, h, binw;
    float* colorData;
    
    VarDrawerSettings* settings;


public:
    VarVisualTimeHistogramMeta();
	VarVisualTimeHistogramMeta(VarDrawer* drawer, 
        DocumentManager* docManager, bool brushed, bool hier);
	~VarVisualTimeHistogramMeta();

    VisualElement* InstantVisualElement();
    void Convert(VisualElement* visualEle, DocElement* docEle);
    void GetVisualElement(VisualElement* visEle, int dimID);

protected:
    void GetHistogramBitMap_line(int binNum, int* histogram, int maxNum);
    void GetHistogramBitMap_period(int binNum, int* histogram, int maxNum);
    void GetUnitTextureSize(int matrix_w, int matrix_h, int unit_w, int unit_h, int gap_w, int gap_h, int &total_w, int &total_h);
    void FillUnitTexture(int matrix_w, int matrix_h, RGBt **color_matrixA, RGBt **color_matrixB, double **ratio_AB, int unit_w, int unit_h, RGBt background, int gap_w, int gap_h, float *pixels);

private:
    void FillRectangle(int total_w, int total_h, int left, int top, int w, int h, RGBt c, float *pixels);


};

#endif

