#include <FLOAT.h>
#include <sstream>

#include "../../MainApplication.h"
#include "VideoClipDrawer.h"
#include "VideoClipVisualRow.h"
#include "VideoClipVisualRowMeta.h"
#include "VideoClipVisualAxesMeta.h"
#include "../../Interface/ViewImageWindow.h"


VideoClipDrawer::VideoClipDrawer() : TableDrawer()
{
	settings = new VideoClipDrawerSettings();
    AddLayer(ITEM);
}


VideoClipDrawer::~VideoClipDrawer()
{
    delete settings;
}

void VideoClipDrawer::PrepareCanvas()
{
    canvas->SetCurrent();
//    canvas->SetLowerLeftOrigin();
    canvas->SetTopLeftOrigin();
    canvas->SetViewport();

//    canvas->SetBackground(colorManager->GetColor(BG));
    canvas->SetBackground(RGBt(0, 0, 0, 1));
    canvas->Clear();

    glEnable(GL_DEPTH_TEST);
    glClear(GL_DEPTH_BUFFER_BIT);
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);


}

//before drawer draws a canvas
void VideoClipDrawer::PrepareDrawLayer(Layer* layer)
{
    TableDrawer::PrepareDrawLayer(layer);
    canvas->SetCurrent();
    if (layer->IsTranslucent())
    {
        // Turn on Translucency
        glEnable(GL_BLEND);
        glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
    }
}

//after drawer draws a canvas
void VideoClipDrawer::AfterDrawLayer(Layer* layer)
{
    if (layer->IsTranslucent())
    {
        // Turn off Translucency
  //      glDisable(GL_BLEND);
    }
}

void VideoClipDrawer::DrawItem(VisualItem *item)
{
    VideoClipVisualItem* visItem= (VideoClipVisualItem *)item;
    //Moh: Add your code here
    //draw the clip item on the screen
    //the following is a sample code I used to draw the image glyph
    
    /*    int VideoClipID = visRow->GetItemID();
    if (settings->IsShowSelectedOnly())
    {
        if (settings->IsTextureSelected(VideoClipID) == false)
            return;
    }
	float xPos = visRow->GetXPosition();
	float yPos = visRow->GetYPosition();
	float zPos = visRow->GetZPosition();
	float xSize = visRow->GetXSize();
	float ySize = visRow->GetYSize();

	glColor4f(1,1,1,1);
	glEnable( GL_TEXTURE_2D );
	
    glBindTexture( GL_TEXTURE_2D, visRow->GetTexture());

 	glBegin(GL_QUADS);
	glTexCoord2d(0.0,0.0); glVertex3d(xPos-xSize,yPos-ySize, zPos);
	glTexCoord2d(1.0,0.0); glVertex3d(xPos+xSize,yPos-ySize, zPos);
	glTexCoord2d(1.0,1.0); glVertex3d(xPos+xSize,yPos+ySize, zPos);
	glTexCoord2d(0.0,1.0); glVertex3d(xPos-xSize,yPos+ySize, zPos);
	glEnd();

	glDisable( GL_TEXTURE_2D );

    if (settings->IsSelectedTextureHighlighted())
    {
        if (VideoClipID == settings->GetFocusTextureID())
        {
            glColor4f(1.f, 0.f, 0.f, 1.f);
	        glLineWidth(1.5);
            glBegin(GL_LINE_STRIP);
            float pad = 1e-5;
            glVertex3f(xPos-xSize,yPos-ySize, zPos+pad);
            glVertex3f(xPos+xSize,yPos-ySize, zPos+pad);
            glVertex3f(xPos+xSize,yPos+ySize, zPos+pad);
            glVertex3f(xPos-xSize,yPos+ySize, zPos+pad);
            glVertex3f(xPos-xSize,yPos-ySize, zPos+pad);
            glEnd();
        }
        else if (VideoClipID == settings->GetBaseTextureID())
        {
            glColor4f(1.f, 0.f, 1.f, 1.f);
	        glLineWidth(1.5);
            glBegin(GL_LINE_STRIP);
            float pad = 1e-5;
            glVertex3f(xPos-xSize,yPos-ySize, zPos+pad);
            glVertex3f(xPos+xSize,yPos-ySize, zPos+pad);
            glVertex3f(xPos+xSize,yPos+ySize, zPos+pad);
            glVertex3f(xPos-xSize,yPos+ySize, zPos+pad);
            glVertex3f(xPos-xSize,yPos-ySize, zPos+pad);
            glEnd();
        }
        else if (settings->IsTextureSelected(VideoClipID))
        {
            glColor4f(0.f, 1.f, 0.f, 1.f);
	        glLineWidth(1.5);
            glBegin(GL_LINE_STRIP);
            float pad = 1e-5;
            glVertex3f(xPos-xSize,yPos-ySize, zPos+pad);
            glVertex3f(xPos+xSize,yPos-ySize, zPos+pad);
            glVertex3f(xPos+xSize,yPos+ySize, zPos+pad);
            glVertex3f(xPos-xSize,yPos+ySize, zPos+pad);
            glVertex3f(xPos-xSize,yPos-ySize, zPos+pad);
            glEnd();
        }
    }*/
}


VisualElementMeta* VideoClipDrawer::CreateVisualRowMeta(DocumentManager* docManager, bool brushed, bool hier)
{
    VideoClipVisualRowMeta *meta = new VideoClipVisualRowMeta(this, docManager, brushed, hier);
    return meta;
}

VisualElementMeta* VideoClipDrawer::CreateVisualAxesMeta()
{
    VideoClipVisualAxesMeta *meta = new VideoClipVisualAxesMeta(this);
    return meta;
}


int VideoClipDrawer::FindItemID(float x, float y)
{
    return settings->GetTextureID(x, y);
}

/*
int VideoClipDrawer::FindItemID(float x, float y)
{
    Layer* axesLayer;
    VisualElementsIterator *visAxesIter;
    VisualElementMeta *axesMeta;
    Iterator *axesIter; 

    VideoClipVisualAxes *axes;

    axesLayer = new Layer(AXES);
    axesMeta = axesLayer->CreateVisualElementMeta(this, docManager);
    axesIter = docManager->GetElementsIterator(AXES, axesMeta);
    visAxesIter  = new VisualElementsIterator(axesMeta, axesIter); 
    
    axes = (VideoClipVisualAxes *)(visAxesIter->GetNext());

    int item = -1;
    float sdis = DBL_MAX;
    float dis, x1, y1, xpos, ypos;
    int n;
    
    IPHash *xyHash = settings->GetCenterXYHash();
    IPHash::iterator it;
    Vec2 *p;
    for( it = xyHash->begin(); it != xyHash->end(); ++it )
    {
        p = (Vec2*)(it->second);
        x1 = fabs(x - p->X);
        y1 = fabs(y - p->Y);
        dis = sqrt(x1 * x1 + y1 * y1);
        if (dis < sdis)
        {
            sdis = dis;
            n = it->first;
        }
    }

    int id;
    if (sdis < 1.7)
        id = n;
    else
        id = -1;

    delete axesLayer;
    delete axesIter;
    delete axesMeta;
    delete visAxesIter;

    return id;
}
*/
void VideoClipDrawer::DoubleClick(grCanvas* canvas, int button, Vec2 p)
{
    Drawer::DoubleClick(canvas, button, p);
    int itemID = FindItemID(p.X, p.Y);
    if (itemID >= 0)
    {
        if (button == 0)
        {
            wxString imgFile = wxString::Format("C:\\yangjing\\Fan\\Querydb\\%d.jpg", itemID);
            ViewImageWindow *win = new ViewImageWindow(imgFile);
            win->Show(TRUE);
        }
    }
}

void VideoClipDrawer::ButtonDown(grCanvas* canvas, int button, Vec2 p)
{
    Drawer::ButtonDown(canvas, button, p);
    inputMode = VideoClip_NONE;
    int itemID = FindItemID(p.X, p.Y);
    if (itemID >= 0)
    {
        if (button == 0)
        {
            if (canvas->IsShiftKey())
            {
                inputMode = VideoClip_MOVE;
                canvas->SetHandCursor();
                currentItem = itemID;
                settings->BringTextureToFront(itemID);
            }
            else
            {
                settings->BringTextureToFront(itemID);
                Refresh();
            }
        }
    }
}


void VideoClipDrawer::ButtonUp(grCanvas* canvas, int button, Vec2 p)
{
    Drawer::ButtonUp(canvas, button, p);
    if (inputMode == VideoClip_MOVE)
    {
        canvas->SetDefaultCursor();
        inputMode = VideoClip_NONE;
    }
    else
    {
        if (button == 2)
        {
            int itemID = FindItemID(p.X, p.Y);
            if (itemID >= 0)
            {
                if (!settings->IsTextureDistorted(itemID))
                    settings->AddDistortedTexture(itemID);
                else
                    settings->RemoveDistortedTexture(itemID);

                settings->BringTextureToFront(itemID);
            }
            Refresh();
        }
        else if (button == 1)
        {
            int itemID = FindItemID(p.X, p.Y);
            if (itemID >= 0)
            {
                std::ostringstream oss;
                oss << itemID << ".jpg";
                
                if (viewManager->GetMainFrame()->GetMDSControlFrame() != NULL)
                    viewManager->GetMainFrame()->GetMDSControlFrame()->SetBaseItem(oss.str());
            }
        }
    }
}

void VideoClipDrawer::MouseMotion(grCanvas* canvas, Vec2 p)
{
    Drawer::MouseMotion(canvas, p);
    if (inputMode == VideoClip_MOVE)
    {
        settings->SetTextureXYPosition(currentItem, p.X, p.Y);
        canvas->Refresh();      
    }
    else
    {
        int itemID = FindItemID(p.X, p.Y);
        if (itemID >= 0)
        {
            std::ostringstream oss;
            oss << itemID << ".jpg";
            canvas->WriteMessage(oss.str().c_str(), 0);
        }
    }
}


void VideoClipDrawer::SelectedItemsChanged()
{
    VideoClipDrawerSettings *settings = GetSettings();
    settings->SelectedItemsChanged();
    LinkListIterator* iter;

    iter = new LinkListIterator(&canvasList);
    grCanvas* canv;
    while (! iter->IsDone())
    {
        canv = (grCanvas *) iter->GetNext();
        canv->DeleteVarTextures();
    }

    delete iter;
}
