#include <stdio.h>
#include "VideoClipVisualRow.h"

VideoClipVisualRow::VideoClipVisualRow() : VisualRow()
{
}

VideoClipVisualRow::~VideoClipVisualRow()
{
}

void VideoClipVisualRow::SetTexture(GLuint texture)
{
	this->texture = texture;
}

void VideoClipVisualRow::SetMaskTexture(GLuint texture)
{
	this->maskTexture = texture;
}
//width: the width of the original texture object
void VideoClipVisualRow::SetWidth(int width)        
{	
	this->width = width;
}

//height: the height of the origianl texture object
void VideoClipVisualRow::SetHeight(int height)      
{
	this->height = height;
}

void VideoClipVisualRow::SetXPosition(float x)
{
	xPos = x;
}

void VideoClipVisualRow::SetYPosition(float y)
{
	yPos = y;
}

void VideoClipVisualRow::SetZPosition(float z)
{
	zPos = z;
}

void VideoClipVisualRow::SetXSize(float x)
{
	xSize = x;
}

void VideoClipVisualRow::SetYSize(float y)
{
	ySize = y;
}

GLuint VideoClipVisualRow::GetTexture()
{
	return texture;
}

//width: the width of the original texture object
int VideoClipVisualRow::GetWidth()        
{	
	return width;
}

//height: the height of the origianl texture object
int VideoClipVisualRow::GetHeight()      
{
	return height;
}

float VideoClipVisualRow::GetXPosition()
{
    float size = GetXSize();
    if ( (xPos - size) < 0 )
        return size;
    else if ( (xPos + size) > 1 )
        return 1-size;
    else
    	return xPos;
}

float VideoClipVisualRow::GetYPosition()
{
    float size = GetYSize();
    if ( (yPos - size) < 0 )
        return size;
    else if ( (yPos + size) > 1 )
        return 1-size;
    else
    	return yPos;
}

float VideoClipVisualRow::GetZPosition()
{
	return zPos;
}

float VideoClipVisualRow::GetXSize()
{
    if (width > height)
    	return xSize;
    else
        return xSize * ((float)width) / height;
}

float VideoClipVisualRow::GetYSize()
{
    if (height > width)
        return ySize;
    else
        return ySize * ((float)height) / width;
}