#ifndef _VISUAL_ELEMENT_META_H
#define _VISUAL_ELEMENT_META_H

#include "VisualElement.h"
#include "../DataStructure/DocElement.h"

class TableDrawer;
class VisualElement;

class VisualElementMeta
{
public:
    int type;

    //there are two modes of meta, meta using counter and mete not using counter
    //when counter is not used, meta does not control the number of visele generated
    //otherwise meta keeps counting of the viseles and knows when to get visele from 
    //docele and when to get visele directly from its own storage. 

    bool useCounter;
    //the following variables are used only when useCounter is true
    int count;      //the counter
    int totalNum;   //the total number of visElements
    int* howGet;     //indicates if the visele to be converted from docele or not

public:
	VisualElementMeta();
	VisualElementMeta(TableDrawer* drawer);
	virtual ~VisualElementMeta();

    int GetType() {return type;}

    bool UseCounter() {return useCounter;}

    virtual VisualElement* InstantVisualElement();
    virtual void Convert(VisualElement* visualData, DocElement* data);

    void SetUpCounter(int totalNum);
    bool IsDone();
    int GetNextHowGet(); 
    virtual void GetVisualElement(VisualElement* visEle, int howGet) {return;}
};

#endif

