#include "../Basic/Iterator.h"
#include "VisualElementsIterator.h"
#include "../basic/macros.h"


VisualElementsIterator::VisualElementsIterator(VisualElementMeta *meta, Iterator *eleIter)
{
    this->visEle = meta->InstantVisualElement();
    this->meta = meta;
    this->eleIter = eleIter;
}	

VisualElementsIterator:: ~VisualElementsIterator()
{
    delete visEle;
}

void* VisualElementsIterator::GetNext()
{
    //there are two modes of meta, meta using counter and mete not using counter
    //when counter is not used, meta does not control the number of visele generated
    //otherwise meta keeps counting of the viseles and knows when to get visele from 
    //docele and when to get visele directly from its own storage. 
    //in particular, if howGet is unknown, meta converts a docele into visele
    //otherwise it gets the visele by itself
    if (meta->UseCounter())
    {
        int howGet = meta->GetNextHowGet();
        if ( howGet == UNKNOWN)
        {
            DocElement* ele = (DocElement *)(eleIter->GetNext());
            meta->Convert(visEle, ele);
        }
        else
        {
            meta->GetVisualElement(visEle, howGet);
        }
        return visEle;
    }
    else
    {
        DocElement* ele = (DocElement *)(eleIter->GetNext());

        meta->Convert(visEle, ele);

        return visEle;
    }
}

bool VisualElementsIterator::IsDone()
{
    if (eleIter == NULL)
        return true;
    if (meta->UseCounter())
    {
        return meta->IsDone();
    }
    else
        return eleIter->IsDone();
}


