//GLFrame is a frame with a gl canvas in it. Basic canvas 
//operations, such as zooming, panning, image saving can be 
//performed in this frame

//if you need to create a "drawable" window, you can derived it from this class  

#ifndef GLFRAME_H
#define GLFRAME_H

#include <wx/wx.h>
#include <wx/filedlg.h>
#include "Frame.h"

class grCanvas;

enum   //use 101 - 199
{ 
	VSCRBAR  =          101,
	HSCRBAR  =          102,

	MENU_SAVEIMAGE =    103,

    TEXT_XZOOM =        104,
    TEXT_YZOOM =        105,
    
    BUTTON_XZOOMPP =    106,
    BUTTON_XZOOMP =     107,
    BUTTON_XZOOMMM =    108,
    BUTTON_XZOOMM =     109,
    BUTTON_XZOOMR =     110,

    BUTTON_YZOOMPP =    111,
    BUTTON_YZOOMP =     112,
    BUTTON_YZOOMMM =    113,
    BUTTON_YZOOMM =     114,
    BUTTON_YZOOMR =     115,
};


class GLFrame : public Frame
{
protected:
	grCanvas *canvas;
	wxMenuBar  *menuBar;

    wxBoxSizer *topSizer;
	wxBoxSizer *quickButtonSizer;
	wxBoxSizer *majorSizer;

    wxScrollBar* vScrBar;
    wxScrollBar* hScrBar;

    wxTextCtrl* xZoomText;
    wxTextCtrl* yZoomText;

    wxButton* xZoomPlusButton;
    wxButton* xZoomPlusPlusButton;
    wxButton* xZoomResetButton;
    wxButton* xZoomMinusButton;
    wxButton* xZoomMinusMinusButton;

    wxButton* yZoomPlusButton;
    wxButton* yZoomPlusPlusButton;
    wxButton* yZoomResetButton;
    wxButton* yZoomMinusButton;
    wxButton* yZoomMinusMinusButton;
  public:
	GLFrame(wxFrame *parent, int id, const wxChar *title, int xpos, int ypos, int width, int height);
	~GLFrame();

    grCanvas* GetCanvas() {return canvas;}
	
    void SetVScrollBar();
    void SetHScrollBar();
    void OnScrBarThumbTrack(wxScrollEvent& event);

    void OnSaveImage(wxCommandEvent& event);
    void OnXZoomTextEnter(wxCommandEvent& event);
    void OnYZoomTextEnter(wxCommandEvent& event);

    void OnXZoomPlusPlus(wxCommandEvent& event);
    void OnXZoomPlus(wxCommandEvent& event);
    void OnXZoomReset(wxCommandEvent& event);
    void OnXZoomMinusMinus(wxCommandEvent& event);
    void OnXZoomMinus(wxCommandEvent& event);

    void OnYZoomPlusPlus(wxCommandEvent& event);
    void OnYZoomPlus(wxCommandEvent& event);
    void OnYZoomReset(wxCommandEvent& event);
    void OnYZoomMinusMinus(wxCommandEvent& event);
    void OnYZoomMinus(wxCommandEvent& event);

	DECLARE_EVENT_TABLE()
};


#endif

