// The interface for setting control modes and parameters of the var display

#ifndef MDSControlFrame_H
#define MDSControlFrame_H

#include <wx/wx.h>
#include <wx/filedlg.h>
#include "Frame.h"

enum  //use 301 - 399
{ 
    COMBO_ACTItem = 301,
    COMBO_GRPItem = 302,
    COMBO_GRPVALUEItem = 303,
    COMBO_ORDERBYItem1 = 304,
    COMBO_ORDERBYItem2 = 305,
    COMBO_ORDERBYItem3 = 306,
    COMBO_BASEItem = 307,
    BUTTON_RANDOMZ = 308,

    COMBO_XItem = 309,
    COMBO_YItem = 310,

    COMBO_CENTERItem = 311,

    RADIO_SELECTIIONDISPLAY = 312,

    BUTTON_RESAMPLEIMAGE = 313,

};


class MDSControlFrame: public Frame
{
 protected:
	wxMenuBar  *menuBar;

    wxBoxSizer *topSizer;
	wxBoxSizer *quickButtonSizer;
	wxBoxSizer *majorSizer;

    wxSlider* sizeSlider;
    wxSlider* simiSelectSlider;
    wxSlider* distinctSelectSlider;
    wxSlider* distortionSlider;

    wxSlider* maskSlider;

    wxSlider* speedSlider;
    
    wxComboBox* baseItemComboBox;
//    wxComboBox* groupItemComboBox;
//    wxComboBox* groupValueComboBox;

    wxRadioBox* selectionDisplayRadioBox;

    wxComboBox* xItemComboBox;
    wxComboBox* yItemComboBox;

    wxButton* maskColorButton;
    wxButton* resampleButton;

    int pre_simivalue;
    int pre_displayMode;

 public:
	MDSControlFrame(wxFrame *parent, int id, const wxChar *title, int xpos, int ypos, int width, int height);
	~MDSControlFrame();

    void OnScroll(wxScrollEvent& event);

    void Reset();
    void SetBaseItem(wxCommandEvent& event);
    void RandomizeZ(wxCommandEvent& event);

    void SetSelectionDisplayMode(wxCommandEvent& event);

    void SetBaseItem(std::string str);

    void WindowClose(wxCloseEvent& event);

    void Resample(wxCommandEvent& event);


	DECLARE_EVENT_TABLE()

};


#endif

