#include "MediaCtrl.h"
#include "ViewMultipleVideoWindow.h"
#include "interface/ViewVideoWindow.h"

BEGIN_EVENT_TABLE(MediaCtrl, wxMediaCtrl)
    EVT_LEFT_DOWN(MediaCtrl::OnLeftMouseDown)
    EVT_RIGHT_DOWN(MediaCtrl::OnRightMouseDown)
    EVT_LEFT_DCLICK(MediaCtrl::OnLeftMouseDoubleClick)
    EVT_MEDIA_STOP(wxID_ANY, MediaCtrl::OnMediaStop)

    EVT_MENU(MEDIACTRL_MENU_UNMUTE, MediaCtrl::OnMenuUnmute)
    EVT_MENU(MEDIACTRL_MENU_MUTE, MediaCtrl::OnMenuMute)
    EVT_MENU(MEDIACTRL_MENU_PAUSE, MediaCtrl::OnMenuPause)
    EVT_MENU(MEDIACTRL_MENU_PAUSE, MediaCtrl::OnMenuPlay)
    EVT_MENU(MEDIACTRL_MENU_STOP, MediaCtrl::OnMenuStop)
    EVT_MENU(MEDIACTRL_MENU_STOPALL, MediaCtrl::OnMenuStopAll)
    EVT_MENU(MEDIACTRL_MENU_PLAYALL, MediaCtrl::OnMenuPlayAll)
    EVT_MENU(MEDIACTRL_MENU_PAUSEALL, MediaCtrl::OnMenuPauseAll)
    EVT_MENU(MEDIACTRL_MENU_MUTEALL, MediaCtrl::OnMenuMuteAll)
END_EVENT_TABLE()

MediaCtrl::MediaCtrl(wxWindow* parent, wxWindowID id, const wxString& fileName)
        :wxMediaCtrl(parent, id, fileName, wxDefaultPosition, wxDefaultSize, 0, wxMEDIABACKEND_DIRECTSHOW)
{
    this->fileName = fileName;
    menu = new wxMenu;
	menu->Append(MEDIACTRL_MENU_UNMUTE,  "UnMute");
	menu->Append(MEDIACTRL_MENU_MUTE,  "Mute");
    menu->Append(MEDIACTRL_MENU_PAUSE,  "Pause");
    menu->Append(MEDIACTRL_MENU_PAUSE,  "Play");
    menu->Append(MEDIACTRL_MENU_STOP,  "Stop");
    menu->Append(MEDIACTRL_MENU_PAUSEALL,  "Pause all");
    menu->Append(MEDIACTRL_MENU_PLAYALL,  "Play all");
    menu->Append(MEDIACTRL_MENU_STOPALL,  "Stop all");
    menu->Append(MEDIACTRL_MENU_MUTEALL,  "Mute all");

}

MediaCtrl::~MediaCtrl()
{
    delete menu;
}

void MediaCtrl::OnLeftMouseDown(wxMouseEvent& event)
{
    ((ViewMultipleVideoWindow*)GetParent())->ResetCurrentMediaCtrl(this);
    SetVolume(1.0);
    SetPlaybackRate(1.0);

}

void MediaCtrl::OnRightMouseDown(wxMouseEvent& event)
{
    PopupMenu(menu);
}


void MediaCtrl::OnLeftMouseDoubleClick(wxMouseEvent& event)
{
 //   double speed = GetPlaybackRate();
 //   SetPlaybackRate(speed*2);
    ViewVideoWindow *videoWnd = new ViewVideoWindow(fileName);
    videoWnd->Show(true);
    videoWnd->Play();

    SetVolume(1e-5);
}

void MediaCtrl::OnMediaStop(wxMediaEvent& event)
{
    Play();
}

void MediaCtrl::OnMenuUnmute(wxCommandEvent& event)
{
    SetVolume(1.0);
}

void MediaCtrl::OnMenuMute(wxCommandEvent& event)
{
    SetVolume(1e-5);
}

void MediaCtrl::OnMenuPause(wxCommandEvent& event)
{
    Pause();
}

void MediaCtrl::OnMenuPlay(wxCommandEvent& event)
{
    Play();
}

void MediaCtrl::OnMenuStop(wxCommandEvent& event)
{
    Stop();
}

void MediaCtrl::OnMenuStopAll(wxCommandEvent& event)
{
    ((ViewMultipleVideoWindow*)GetParent())->StopAll();
}

void MediaCtrl::OnMenuPauseAll(wxCommandEvent& event)
{
    ((ViewMultipleVideoWindow*)GetParent())->PauseAll();
}

void MediaCtrl::OnMenuPlayAll(wxCommandEvent& event)
{
    ((ViewMultipleVideoWindow*)GetParent())->PlayAll();
}

void MediaCtrl::OnMenuMuteAll(wxCommandEvent& event)
{
    ((ViewMultipleVideoWindow*)GetParent())->MuteAll();
}

