#include <wx/wx.h>
#include "Mediactrl.h"
#include "ViewMultipleVideoWindow.h"

BEGIN_EVENT_TABLE(ViewMultipleVideoWindow, wxFrame)
//    EVT_PAINT(ViewMultipleVideoWindow::OnPaint)
//    EVT_SIZE(ViewMultipleVideoWindow::OnSize)
END_EVENT_TABLE()

ViewMultipleVideoWindow::ViewMultipleVideoWindow(int num, wxString *videoFile) : 
    wxFrame(NULL, -1, videoFile[0])
{
//    SetTitle(videoFile.Right(videoFile.Length() - videoFile.Find('\\', true) - 1));
    this->num = num;
    this->videoFile = videoFile;
    int rows = ceil(sqrt((double)num));
    int columns = ceil(((double)num) / rows);

    sizer = new wxGridSizer(rows, columns, 1, 1);
	SetSizer( sizer );   

    mediaCtrls = new MediaCtrl* [num];
    for(int i = 0; i < num; i++)
    {
        mediaCtrls[i] = new MediaCtrl(this, i+1000, videoFile[i]);
        sizer->Add(mediaCtrls[i], 1, wxEXPAND | wxALL, 0);
    }

    currMediaCtrl = NULL;
}

ViewMultipleVideoWindow::~ViewMultipleVideoWindow()
{
}

void ViewMultipleVideoWindow::Play()
{
    for(int i = 0; i < num; i++)
    {
        if (mediaCtrls[i] != NULL)
        {
            mediaCtrls[i]->Play();
            //wxMEDIABACKEND_DIRECTSHOW you have to use 1e-5 rather than 0. For others you cna use 0
            mediaCtrls[i]->SetVolume(1e-5);
        }
        mediaCtrls[0]->SetVolume(1);
        currMediaCtrl = mediaCtrls[0];
    }
}


void ViewMultipleVideoWindow::ResetCurrentMediaCtrl(MediaCtrl *current)
{
    if (currMediaCtrl != NULL)
    {
        currMediaCtrl->SetVolume(1e-5);
        currMediaCtrl->SetPlaybackRate(2.0);
    }
    currMediaCtrl = current;

}

void ViewMultipleVideoWindow::MuteAll()
{
    for(int i = 0; i < num; i++)
    {
        if (mediaCtrls[i] != NULL)
        {
            //wxMEDIABACKEND_DIRECTSHOW you have to use 1e-5 rather than 0. For others you cna use 0
            mediaCtrls[i]->SetVolume(1e-5);
//            mediaCtrls[i]->SetPlaybackRate(2.0);
        }
    }
}

void ViewMultipleVideoWindow::PlayAll()
{
    for(int i = 0; i < num; i++)
    {
        if (mediaCtrls[i] != NULL)
        {
            //wxMEDIABACKEND_DIRECTSHOW you have to use 1e-5 rather than 0. For others you cna use 0
            mediaCtrls[i]->Play();
        }
    }
}

void ViewMultipleVideoWindow::PauseAll()
{
    for(int i = 0; i < num; i++)
    {
        if (mediaCtrls[i] != NULL)
        {
            //wxMEDIABACKEND_DIRECTSHOW you have to use 1e-5 rather than 0. For others you cna use 0
            mediaCtrls[i]->Pause();
        }
    }
}

void ViewMultipleVideoWindow::StopAll()
{
    for(int i = 0; i < num; i++)
    {
        if (mediaCtrls[i] != NULL)
        {
            //wxMEDIABACKEND_DIRECTSHOW you have to use 1e-5 rather than 0. For others you cna use 0
            mediaCtrls[i]->Stop();
        }
    }
}