#ifndef MAINAPPLICATION_H
#define MAINAPPLICATION_H

#include <string>
#include "ViewManager.h"
#include "DocumentManager.h"
#include "Interface/MainFrame.h"

//the program enters and exits from this class
class MainApplication : public wxApp
{
protected:
    //viewManager is in charge of graph drawing in the program
    //docManager is in charge of data managemenet in the program
    //mainFrame is the main window of the program, It is in charge of the interface
    ViewManager* viewManager;
    DocumentManager *docManager;
    MainFrame* mainFrame;

public:
    //this is the main entrance of the program 
    bool OnInit();
    
    //this is the main exit of the program 
    int OnExit();

    DocumentManager* GetDocumentManager();

};

//this is required by wxWidgets to declare the main application
DECLARE_APP(MainApplication) 


#endif

