#include <wx/wx.h>
#pragma warning(disable:4663)    // unreferenced formal parameter
//#include <string>
#include "MainApplication.h"
#include "ViewManager.h"
#include "Interface/MainFrame.h"
#include "Interface/VarControlFrame.h"
#include "Interface/MDSControlFrame.h"
#include "Basic/macros.h"

IMPLEMENT_APP(MainApplication)

bool MainApplication::OnInit()
{
/*    magentaColors = NULL;
    heatedObjectColors = NULL;
 
    colorManager = new ColorManager();


*/	

    viewManager = new ViewManager();
    docManager = new DocumentManager();
    viewManager->SetDocumentManager(docManager);
    docManager->SetViewManager(viewManager);

  //  docManager->SetDBMode(true);
    docManager->SetDBMode(false);

    frame = new MainFrame("Visualization Tool Demo", 0, 0, 700, 850);
  //  viewManager->AssignDrawerToCanvas(frame->GetCanvas(), VAR);
 //   viewManager->AssignDrawerToCanvas(frame->GetCanvas(), PARCOORD);
    viewManager->AssignDrawerToCanvas(frame->GetCanvas(), GLYPH);

//    vFrame = new VarControlFrame("VaR Control", 700, 0, 450, 600);
    mdsFrame = new MDSControlFrame("Glyph Control", 700, 0, 450, 700);
//    vFrame->SetViewManager(viewManager);
    mdsFrame->SetViewManager(viewManager);

	frame->Show(TRUE);
//	SetTopWindow(frame);
//    vFrame->Show(true);
    mdsFrame->Show(true);

	return TRUE;	
}

void MainApplication::ChangeDisplayType(GLFrame *frame, int type)
{
    viewManager->AssignDrawerToCanvas(frame->GetCanvas(), type);
}

int MainApplication::OnExit()
{
     delete docManager;
     delete viewManager;

/*    if (colorManager != NULL)
        delete colorManager;

    if (magentaColors != NULL)
    {
        for (int i = 0; i < 256; i++)
            delete magentaColors[i];
        delete magentaColors;
    }
    if (heatedObjectColors != NULL)
    {
        for (int i = 0; i < 256; i++)
            delete heatedObjectColors[i];
        delete heatedObjectColors;
    }
*/
    return 0;
}


bool MainApplication::OpenFile(std::string fileName)
{
    if (docManager->OpenDataSet(fileName))
    {
        //vFrame->Reset();
        mdsFrame->Reset();
        viewManager->RefreshAll();
        return true;
    }
    else
        return false;
}

DocumentManager* MainApplication::GetDocumentManager()
{
    return docManager;
}

/*ViewManager* MainApplication::GetViewManager()
{
    return viewManager;
}*/
/*
ColorManager* MainApplication::GetColorManager()
{
    return colorManager;
}
*/
/*
bool MainApplication::DeleteDocumentManager()
{
    if (docManager != NULL)
    {
        delete docManager;
        docManager = NULL;
    }

    return true;
}

bool MainApplication::CreateDocumentManager(std::string fileName)
{
    docManager = new DocumentManager(fileName);
    if (docManager->IsValid())
        return true;
    else
        return false;
}
*/

/*bool MainApplication::LoadMagentaColorData()
{
    FILE *fptr = fopen("ColorData\\magenta.dat","rb");
    if (!fptr) 
        return false;
    else
        fclose(fptr);

    std::ifstream infile("ColorData\\magenta.dat");
   
    magentaColors = new RGBt * [256];
    int r, g, b;
    for (int i = 0; i < 256; i++)
    {
        infile >> r;
        infile >> g;
        infile >> b;
        magentaColors[i] = new RGBt(r/255., g/255., b/255.);
    }
    infile.close();

    return true;
}

bool MainApplication::LoadHeatedObjectColorData()
{
    FILE *fptr = fopen("ColorData\\heatedobject.dat","rb");
    if (!fptr) 
        return false;
    else
        fclose(fptr);

    std::ifstream infile("ColorData\\heatedobject.dat");
   
    heatedObjectColors = new RGBt * [256];
    int r, g, b;
    for (int i = 0; i < 256; i++)
    {
        infile >> r >> g >> b;
        heatedObjectColors[i] = new RGBt(r/255., g/255., b/255.);
    }
    infile.close();

    return true;
}

bool MainApplication::IsMagentaColorAvailable()
{
    if (magentaColors != NULL)
        return true;
    else
        return LoadMagentaColorData();
}

bool MainApplication::IsHeatedObjectColorAvailable()
{
    if (heatedObjectColors != NULL)
        return true;
    else
        return LoadHeatedObjectColorData();
}

RGBt** MainApplication::GetMagentaColors()
{
    return magentaColors;
}

RGBt** MainApplication::GetHeatedObjectColors()
{
    return heatedObjectColors;
}
*/