#ifndef UTIL_H
#define UTIL_H

/****************************************************************/
/* headers                                                      */
/****************************************************************/
#include "general.h"

/****************************************************************/
/* defines                                                      */
/****************************************************************/
#define print_error			if(error)(*error)

#define TOKEN_FILE		0
#define TOKEN_CMDLINE	1

#define MY_MALLOC

#ifndef MY_MALLOC
#define mmalloc(size)		malloc((size))
#define mcalloc(size,nelem)	calloc((size),(nelem))
#define mrealloc(ptr,size)	realloc((ptr),(size))
#define mfree(ptr)			free((ptr))
#endif

/****************************************************************/
/* typedefs                                                     */
/****************************************************************/

/****************************************************************/
/* external variables                                           */
/****************************************************************/
extern void (*error)( char *str );

/****************************************************************/
/* function prototypes											*/
/****************************************************************/
extern void error_tty( char *str );
extern void error_X( char *str );
extern char *mstrdup( char * );
extern void new_str( char **str_ptr, char *str );
extern void tolower_string( char *str );
extern void toupper_string( char *str );
extern void reset_tokens( int mode, FILE *fp, int argc, char **argv );
extern int get_token( char *tok, int size );
extern int unget_token( char *tok );
extern char *strip_quotes( char *str );
#ifdef MY_MALLOC
extern char *mmalloc( UINT size );
extern char *mcalloc( UINT nelem, UINT elsize );
extern char *mrealloc( void *oldptr, UINT size );
extern void mfree( void *ptr );
extern UINT get_mem();
#endif

#endif
